<?php declare(strict_types=1);

namespace Plugin\css_gutschein\Migrations;

use JTL\Helpers\Text;
use JTL\Plugin\PluginInterface;
use JTL\Mail\Mail\Mail;
use JTL\Mail\Mailer;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;


use JTL\Shop;
use DirectoryIterator;
use Exception;
use League\Flysystem\Adapter\Local;
use League\Flysystem\Filesystem;
use JTL\Filesystem\AdapterFactory;
use League\Flysystem\Config as FlysystemConfig;
use League\Flysystem\Local\LocalFilesystemAdapter;
use League\Flysystem\Config;
use League\Flysystem\Visibility;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration   {
    /**
     * @inheritdoc
     */

    public $_copyTable = true;

	   public function copyTable($sourceDB,$destinationDB="", $copyTable=true,$deleteSourceDB=false) {
		   if(	$this->_copyTable === false ) {
		   	return;
		   }
		    self::JTLWriteLog('starte copy '.$sourceDB);
        $result = $this->getDB()->query("SHOW TABLES LIKE '".$sourceDB."'",2);
        if($copyTable && $result !== null && is_array($result) && count($result)) {
            error_log('DB Vorhanden '.$sourceDB);
            $result = $this->getDB()->query("SELECT * FROM ".$sourceDB." WHERE 1",2);
            foreach($result as $oItem) {
                error_log('schreibe Datensatz nach '.$destinationDB);
                $this->getDB()->insert($destinationDB,$oItem);
            }
        }
        if($deleteSourceDB) {
            $this->execute("DROP TABLE IF EXISTS ".$sourceDB,3);
        }
    }


    /*
    define('JTLLOG_LEVEL_EMERGENCY', 600);
    define('JTLLOG_LEVEL_ALERT', 550);
    define('JTLLOG_LEVEL_CRITICAL', 500);
    define('JTLLOG_LEVEL_ERROR', 400);
    define('JTLLOG_LEVEL_WARNING', 300);
    define('JTLLOG_LEVEL_NOTICE', 250);
    define('JTLLOG_LEVEL_INFO', 200);
    define('JTLLOG_LEVEL_DEBUG', 100);
*/

    public function JTLWriteLog($cLog='',$nLevel=JTLLOG_LEVEL_INFO ,$bForce=false) {
        if (\mb_strlen($cLog) > 0 && ($bForce || \Jtllog::getSytemlogFlag(false))) {
            $logger = Shop::Container()->getLogService();
            $logger = $logger->withName("css_gutscheinConfig");
            $logger->log($nLevel, $cLog, ["css_gutscheinConfig"]);
            return true;
        }
        return false;
    }


    public function up()    {
        $this->execute("
              CREATE TABLE IF NOT EXISTS `css_gutscheinConfig` (
                  `version` varchar(255) NOT NULL DEFAULT '2.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
								  `timelock` int(10) NOT NULL DEFAULT 600,
								  `voucherPrice` int(10) NOT NULL DEFAULT 0,
								  `voucherText` int(10) NOT NULL DEFAULT 0,
								  `voucherMail` int(10) NOT NULL DEFAULT 0,
								  `voucherName` int(10) NOT NULL DEFAULT 0,
								  `voucherTime` int(10) NOT NULL DEFAULT 0,
								  `voucherImage` int(10) NOT NULL DEFAULT 0,
								  `voucherCode` int(10) NOT NULL DEFAULT 0,
								  `voucherMinPrice` double(10,2) NOT NULL DEFAULT 5.00,
								  `voucherMaxPrice` double(10,2) NOT NULL DEFAULT 200.00,
								  `voucherValidity` int(10) NOT NULL DEFAULT 3,
								  `voucherValidityFrom` tinyint(1) NOT NULL DEFAULT 1,
								  `voucherTemplateSystem` tinyint(3) NOT NULL DEFAULT 0,
								  `cMail` varchar(255) NOT NULL DEFAULT '',
								  `voucherImagesize` varchar(40) NOT NULL DEFAULT 'bilder_artikel_normal_breite',
								  `voucherArtNumber` varchar(60) NOT NULL DEFAULT 'GUTSCHEIN',
								  `voucherOrderStatus` tinyint(2) NOT NULL DEFAULT 4,
								  `voucherZahlungsarten` varchar(255) NOT NULL DEFAULT '',
								  `cronJob` char(1) NOT NULL DEFAULT 'W',
								  `voucherButtonPosition` varchar(10) NOT NULL DEFAULT 'prepend',
								  `voucherButtonSelector` varchar(255) NOT NULL DEFAULT '.product-offer .variations',
								  `voucherGsCodePosition` varchar(10) NOT NULL DEFAULT 'before',
								  `voucherGsCodeSelector` varchar(255) NOT NULL DEFAULT '#complete_order, #fieldset-payment',
								  `freeArticle` char(1) NOT NULL DEFAULT 'N',
								  `couponCodeForVoucher` char(1) NOT NULL DEFAULT 'N',
								  `BasketInfoPosition` varchar(10) NOT NULL DEFAULT 'prepend',
								  `BasketInfoSelector` varchar(255) NOT NULL DEFAULT '.basket_wrapper',
								  `voucherVersandarten` varchar(255) NOT NULL DEFAULT '',
								  `gallerySelector` varchar(255) NOT NULL DEFAULT '#gallery',
								  `priceWrapperSelector` varchar(255) NOT NULL DEFAULT '.price_wrapper',
								  `variationsSelector` varchar(255) NOT NULL DEFAULT '.product-offer .variations',
								  `optionPrintOrSend` varchar(10) NOT NULL DEFAULT 'print',
								  `TOKEN` varchar(255) NOT NULL DEFAULT '',
								  `access` varchar(255) NOT NULL DEFAULT '',
								  `KASSENID` text NOT NULL
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

	    $result = $this->getDB()->query(
		    'SELECT * from `css_gutscheinConfig` where 1',
		    1
	    );
	    self::JTLWriteLog('result: '.print_r($result,true));

	    if($result!==null && !empty($result->version)) {
	    	$this->_copyTable = false;
		    self::JTLWriteLog('Es ist kein Import erforderlich');
	    }

	    $this->copyTable("css_gutschein_konfig","css_gutscheinConfig",true,false);
				$obj = new \stdClass();

			if(	$this->_copyTable === true ) {
				$this->execute("
										UPDATE css_gutscheinConfig SET
											voucherButtonSelector = '.product-offer .variations > .col',
											variationsSelector = '.product-offer .variations > .col'
									");
			}

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_gutscheinBasketCard` (
					  `id` int(10) NOT NULL AUTO_INCREMENT,
					  `kKunde` int(10) NOT NULL DEFAULT 0,
					  `kArtikel` int(10) NOT NULL DEFAULT 0,
					  `kWarenkorbPersPos` int(10) NOT NULL DEFAULT 0,
					  `voucherImageId` int(10) NOT NULL DEFAULT 0,
					  `vouchersendTime` varchar(10) NOT NULL DEFAULT '',
					  `voucherMail` varchar(255) NOT NULL DEFAULT '',
					  `voucherName` varchar(255) NOT NULL,
					  `voucherSenderName` varchar(255) NOT NULL,
					  `voucherText` text NOT NULL,
					  `voucherImage` blob NOT NULL,
					  `voucherPrice` double(10,2) NOT NULL DEFAULT 0.00,
					  `tstamp` int(10) NOT NULL DEFAULT 0,
					  `voucheroptions` text NOT NULL,
					  PRIMARY KEY (`id`)
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");

	    $this->copyTable("css_gutschein_BasketCard","css_gutscheinBasketCard",true,false);

	    $this->execute("
				CREATE TABLE IF NOT EXISTS `css_gutscheinFolders` (
				  `id` int(10) NOT NULL AUTO_INCREMENT,
				  `voucherFolder` int(10) NOT NULL DEFAULT 0,
				  `voucherParent` int(10) NOT NULL DEFAULT 0,
				  `sort` int(10) NOT NULL DEFAULT 0,
				  `voucherImageUrl` varchar(255) NOT NULL DEFAULT '',
				  `voucherActive` char(1) NOT NULL DEFAULT 'Y',
				  PRIMARY KEY (`id`)
				) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");
	    $this->copyTable("css_gutschein_folders","css_gutscheinFolders",true,false);

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_gutscheinFolderLang` (
					  `id` int(10) NOT NULL AUTO_INCREMENT,
					  `pid` int(10) NOT NULL DEFAULT 0,
					  `voucherFolderName` varchar(255) NOT NULL DEFAULT '',
					  `voucherFolderDescription` text NOT NULL,
					  `kSprache_kSprache` int(3) NOT NULL DEFAULT 0,
					  PRIMARY KEY (`id`)
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");
	    $this->copyTable("css_gutschein_folder_lang","css_gutscheinFolderLang",true,false);

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_gutscheinHistory` (
					  `id` int(10) NOT NULL AUTO_INCREMENT,
					  `pid` int(10) NOT NULL DEFAULT 0,
					  `cBestellNr` varchar(20) NOT NULL DEFAULT '',
					  `cMail` varchar(255) NOT NULL DEFAULT '',
					  `kBestellung` int(10) NOT NULL DEFAULT 0,
					  `kWaehrung` int(3) NOT NULL DEFAULT 0,
					  `cStatus` int(3) NOT NULL DEFAULT 0,
					  `usedValue` double(10,2) NOT NULL DEFAULT 0.00,
					  `tstamp` int(10) NOT NULL DEFAULT 0,
					  `kRechnungsadresse` int(10) NOT NULL DEFAULT 0,
					  `kKunde` int(10) NOT NULL DEFAULT 0,
					  PRIMARY KEY (`id`)
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");
	    $this->copyTable("css_gutschein_history","css_gutscheinHistory",true,false);

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_gutscheinImage` (
					  `id` int(10) NOT NULL AUTO_INCREMENT,
					  `voucherFolder` int(10) NOT NULL DEFAULT 0,
					  `voucherSort` int(10) NOT NULL DEFAULT 0,
					  `voucherImageUrl` varchar(255) NOT NULL DEFAULT '',
					  `voucherActive` char(1) NOT NULL DEFAULT 'Y',
					  `voucheroptions` text NOT NULL,
				    `voucherStandard` char(1) NOT NULL DEFAULT '',
					  PRIMARY KEY (`id`)
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");
	    $this->copyTable("css_gutschein_image","css_gutscheinImage",true,false);

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_gutscheinImageToLang` (
					  `imageId` int(10) NOT NULL DEFAULT 0,
					  `kSprache` tinyint(3) NOT NULL DEFAULT 0,
					  `cStandard` char(1) NOT NULL DEFAULT ''
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");
	    $this->copyTable("css_gutschein_imageToLang","css_gutscheinImageToLang",true,false);

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_gutscheinCupon` (
					  `id` int(10) NOT NULL AUTO_INCREMENT,
					  `pid` int(10) NOT NULL,
					  `cBestellNr` varchar(255) DEFAULT NULL,
					  `OrderId` int(10) NOT NULL DEFAULT 0,
					  `kRechnungsadresse` int(10) NOT NULL DEFAULT 0,
					  `kWarenkorbPos` int(10) NOT NULL,
					  `kWaehrung` int(3) NOT NULL,
					  `voucherMail` varchar(255) NOT NULL DEFAULT '',
					  `cMail` varchar(255) NOT NULL DEFAULT '',
					  `voucherCode` varchar(255) DEFAULT NULL,
					  `couponWorth` double(10,2) NOT NULL DEFAULT 0.00,
					  `DateCreate` int(10) NOT NULL DEFAULT 0,
					  `DateExpire` int(10) NOT NULL DEFAULT 0,
					  `restVoucherWorth` double(10,2) NOT NULL DEFAULT 0.00,
					  `valid` tinyint(1) NOT NULL DEFAULT 0,
					  `timeLock` int(11) NOT NULL DEFAULT 0,
					  `timeLockSystem` varchar(255) NOT NULL DEFAULT '',
					  PRIMARY KEY (`id`)
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");
	    $this->copyTable("css_gutschein_kupon","css_gutscheinCupon",true,false);

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_gutscheinOrder` (
					  `id` int(10) NOT NULL AUTO_INCREMENT,
					  `kKunde` int(10) NOT NULL DEFAULT 0,
					  `kRechnungsadresse` int(10) NOT NULL DEFAULT 0,
					  `kSprache` tinyint(3) NOT NULL DEFAULT 0,
					  `kWaehrung` int(3) NOT NULL,
					  `kWarenkorbPos` int(10) NOT NULL DEFAULT 0,
					  `kBestellung` int(10) NOT NULL DEFAULT 0,
					  `cBestellNr` varchar(255) DEFAULT NULL,
					  `voucherImage` int(10) NOT NULL DEFAULT 0,
					  `voucherCode` varchar(50) NOT NULL DEFAULT '',
					  `vouchersendTime` int(10) NOT NULL DEFAULT 0,
					  `vouchersendTimeText` varchar(20) NOT NULL DEFAULT '',
					  `voucherMail` varchar(255) NOT NULL DEFAULT '',
					  `voucherName` varchar(255) NOT NULL,
					  `voucherSenderName` varchar(255) NOT NULL,
					  `cMail` varchar(255) NOT NULL DEFAULT '',
					  `voucherText` text NOT NULL,
					  `voucherPrice` double(10,2) NOT NULL DEFAULT 0.00,
					  `tstamp` int(10) NOT NULL DEFAULT 0,
					  `cStatus` char(2) NOT NULL DEFAULT '',
					  `voucheroptions` text NOT NULL,
					  `system` tinyint(4) NOT NULL DEFAULT 1,
					  PRIMARY KEY (`id`)
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
	    ");
	    $this->copyTable("css_gutschein_Order","css_gutscheinOrder",true,false);

        $result = $this->getDB()->query(
            'SELECT * from `css_gutscheinConfig` where 1',
            2
        );

        if($result === null || count($result) < 1) {
           $this->execute(
            "INSERT INTO `css_gutscheinConfig` (`version`) VALUES ('2.0.0')"
            );
        } else {
            $this->execute("UPDATE css_gutscheinConfig set `version` = '2.0.0' ");
        }

	    if(is_dir(PFAD_ROOT.PFAD_MEDIAFILES.'voucher-fonts') === false) {
		    $fileSystem = new LocalFilesystemAdapter(\PFAD_ROOT);
		    $fileSystem->createDirectory(PFAD_MEDIAFILES.'voucher-fonts',new Config());
		    $fileSystem->setVisibility(PFAD_MEDIAFILES.'voucher-fonts',Visibility::PUBLIC );
		    $dir = "plugins/css_gutschein/fonts/";
		    if ($dh = opendir(PFAD_ROOT.$dir)){
			    while (($file = readdir($dh)) !== false){
				    if($file != '.' && $file != '..' && is_file(PFAD_ROOT.$dir.$file)) {
					    $fileSystem->copy($dir.$file,PFAD_MEDIAFILES.'voucher-fonts/'.$file,new Config());
				    }
			    }
			    closedir($dh);
		    }
	    }
		}

    /**
     * @inheritdoc
     */
    public function down() {
        if ($this->doDeleteData()) {

        }
    }
}
