<?php declare(strict_types=1);

namespace Plugin\css_gutschein\Migrations;

use JTL\Helpers\Text;
use JTL\Plugin\PluginInterface;
use JTL\Mail\Mail\Mail;
use JTL\Mail\Mailer;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;


use JTL\Shop;
use DirectoryIterator;
use Exception;
use League\Flysystem\Adapter\Local;
use League\Flysystem\Filesystem;
use JTL\Filesystem\AdapterFactory;
use League\Flysystem\Config as FlysystemConfig;
use League\Flysystem\Local\LocalFilesystemAdapter;
use League\Flysystem\Config;
use League\Flysystem\Visibility;

class Migration20221201123301 extends Migration implements IMigration {

	public function up() {
		$result = $this->getDB()->query(
			'SELECT * from `css_gutscheinConfig` where 1',
			2
		);

		if ($result === null || count($result) < 1) {
			$this->execute(
				"INSERT INTO `css_gutscheinConfig` (`version`) VALUES ('2.3.0')"
			);
		} else {
			$this->execute("UPDATE css_gutscheinConfig set `version` = '2.3.0' ");
		}

		$this->execute("ALTER TABLE `css_gutscheinConfig` ADD `kSteuerklasse` INT(11) NOT NULL DEFAULT '0'");

	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
