(function () {
    'use strict';

    if (!$.cssVoucher) {
        $.cssVoucher = {'showDebug': false};
    }

    var cssVoucherClass = function (options) {
        this.init(options);
    };

    cssVoucherClass.VERSION = '2.0.0';
    cssVoucherClass.DEFAULTS = {captcha: {}};
    cssVoucherClass.prototype = {

        constructor: cssVoucherClass,

        init: function (options) {
            this.options = $.extend({}, cssVoucherClass.DEFAULTS, options);
            var that = this;
        },


        register: function () {
            this.initAuswahl();
            this.initVoucherAreaLink();
            this.initVoucherProperty();
            this.initPreview();
            this.initDatepicker();
            this.initGsCode();
            this.cssInterval = 0;
        },

        debug: function (s) {
            if (this.options.showDebug) {
                console.log(s);
            }
        },


        post_data: function (url, data) {
            var that = this;
            jQuery.ajax({
                type: 'POST',
                url: url,
                data: data,
                showNoSuggestionNotice: true,
                dataType: 'json',
                beforeSend: function (jqXHR) {
//		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
                },
                success: function (data, responseText, jqXHR) {
                    if (jqXHR.status == 204) {
                        that.debug('sorry, here is nothing to do for me. (Token problem?)')
                        return false;
                    }
                    if (jqXHR.status == 404) {
                        that.debug('sorry, here is nothing to show you.')
                        return false;
                    }
                    if (jqXHR.status == 403) {
                        that.debug('sorry, this is no place for you.')
                        return false;
                    }
                    //debug(data);
                    if (data.script) {
                        eval(data.script);
                    }
                    $("body").trigger('contentChanged');
                },
                error: function () {
                    that.debug('something is wrong....anything buggy?');
                },
                complete: function () {

                }
            });
        },

        initGsCode: function () {
            var that = this;
            console.log("init");
            $(document).on("click", "#cssGsCode-submit", function () {
                console.log("wurde geklickt");
                that.post_data(
                    "io.php",
                    "io=css_gutschein&action=getGSCode&gsCode=" + $("#cssGsCode").val()
                );
            });
        },

        updateVoucher: function (el, action) {
            var that = this;
            that.debug("updateVoucher wird ausgefuehrt.");
            var data = $(el).closest("form").serialize();
            that.debug("form serialize = " + data);
            that.post_data("io.php", "io=css_gutschein&action=" + action + "&" + data);
        },

        initPreview: function () {
            var that = this;
            $("#vorschau").on("click", function () {
                that.debug("#vorchau -> ich wurde geklickt.");
                that.updateVoucher(this, "getBigVoucherPreview");
            });
        },

        initVoucherProperty: function (el) {
            var that = this;
            $(".css_gutschein input[name*='eigenschaftwert'], .css_gutschein textarea[name*='eigenschaftwert']").not(".VoucherDatePicker").on("change", function () {
                that.updateVoucher(this, "getGalleryPreview");
            });

            var lastlength = $.md5($(".css_gutschein textarea.cssVoucherText").val() + $(".css_gutschein input.cssVoucherPrice").val());

            $(".css_gutschein textarea.cssVoucherText, .css_gutschein input.cssVoucherPrice").on("focus", function () {
                var el = this;
                if (typeof that.cssInterval != 'undefined') {
                    clearInterval(that.cssInterval);
                }
                that.cssInterval = setInterval(function () {
                    $("body").trigger("cssUpdatePreis", Number($(".css_gutschein input.cssVoucherPrice").val()));
                    that.debug("update den Textbereich wenn erforderlich");
                    if (lastlength != $.md5($(".css_gutschein textarea.cssVoucherText").val() + $(".css_gutschein input.cssVoucherPrice").val())) {
                        that.updateVoucher($(el), "getGalleryPreview");
                        lastlength = $.md5($(".css_gutschein textarea.cssVoucherText").val() + $(".css_gutschein input.cssVoucherPrice").val());
                    }
                }, 1000);
            });

            $(document).on('evo:changed.article.price', function () {
                that.debug("evo:changed.article.price");
                if ($("input.cssVoucherPrice").length > 0) {
                    $("body").trigger("cssUpdatePreis", Number($(".css_gutschein input.cssVoucherPrice").val()));
// sicherheit, falls das erste Preisupdate wirkungslos ist weil andere sich danach noch mal eingemischt haben.
                    setTimeout(function () {
                        console.log("update den Preis");
                        $("body").trigger("cssUpdatePreis", Number($(".css_gutschein input.cssVoucherPrice").val()));
                    }, 200);
                }
            });

            $(".css_gutschein textarea.cssVoucherText , .css_gutschein input.cssVoucherPrice").on("blur", function () {
                $("body").trigger("cssUpdatePreis", Number($(".css_gutschein input.cssVoucherPrice").val()));
                if (typeof that.cssInterval != 'undefined') {
                    clearInterval(that.cssInterval);
                }
            });
        },


        initVoucherAreaLink: function () {
            var that = this;
            $(".voucher-area-link").on("click", function () {

                // sorgt dafür das das nicht immer neu geladen wird wenn ich die Bilder schon geholt habe
                if ($(this).closest(".panel-default").find(".panel-collapse img").length > 0) return;

                that.debug(".voucher-area-link -> ich wurde geklickt.");
                var id = $(this).data("id");
                that.post_data("io.php", "io=css_gutschein&action=getVoucherItems&area=" + id + "&jtl_token=" + $("input[name='jtl_token']").val());
            });

            setTimeout(function () {
// wurde entfernt weil es nun möglich ist mehrere Gutscheine zu kaufen.
//				$("body.css_gutschein").trigger("cssUpdateMaxbestellmenge",1); 
                $("body.css_gutschein").trigger("cssUpdatePreis", Number($(".css_gutschein input.cssVoucherPrice").val()));
            }, 500);
        },

        initAuswahl: function () {
            var that = this;
            $("#voucherItem").on("click", function () {
                that.debug("#voucherItem -> ich wurde geklickt.");
                that.post_data("io.php", "io=css_gutschein&action=getVoucherAreas" + "&jtl_token=" + $("input[name='jtl_token']").val());
            });
        },

        initVoucherImage: function () {
            var that = this;
            $(".voucher-imageBox").unbind("click");
            $(".voucher-imageBox").on("click", function () {
                that.debug(".initVoucherImage -> ich wurde geklickt.");
                $("input[name='voucherImage']").val($(this).data('id'));
                $("input[data-type='voucherImage']").val($(this).data('id'));
                that.post_data("io.php", "io=css_gutschein&action=getVoucherimageInfo&img=" + $(this).data('id') + "&jtl_token=" + $("input[name='jtl_token']").val());
//					$.cssVouch.post_data("io.php","io=css_gutschein&action=getVoucherAreas");
            });
            $("input[name='voucherImage']").on("change", function () {
                $("input[data-type='voucherImage']").val($(this).val());
            });
        },

        // deaktiviert und durch den pignose Kalender ersetzt in Version 1.03
        initDatepicker: function () {
            /*
                            $('.VoucherDatePicker').datepicker({
                                 language: "de",
                                 autoclose: true,
                                 startDate: $('.VoucherDatePicker').attr("data-startDate")
                           });
            */
        },
    };

    $.cssVoucher.extended = function () {
        return new cssVoucherClass($.cssVoucher);
    };

    $.cssVoucher.error = function () {
        if (console && console.error) {
            console.error(arguments);
        }
    }


    $(document).ready(function () {
        $.cssVoucher.extended().register();
        $.cssVouch = $.cssVoucher.extended();
        if ($("input.cssVoucherPrice").length) {
            $.cssVouch.updateVoucher($("input.cssVoucherPrice"), 'getGalleryPreview');
        }
    });


})(jQuery);


